% Main Test on a maze problem

clc
clear all


% create the maze, N is the number of columns and M is the number of rows;
% maze is a M*N matrix for the maze map, with some obstacles. Please feel
% free to modify the maze map
[maze,N,M,start,goal] = CreateMaze();


% Build the position index of the maze map
statelist = setprod(1:N,1:M);
n_state = size(statelist,1);

% list of the four actions: right, left, up, down
actionlist  = [1;2;3;4];
n_action = size(actionlist,1);

% generate initial value of QTable and Model
Q = zeros(n_state,n_action);  
Model = zeros(n_state,n_action,2);

% planning steps
max_round = 20;

p_steps = 50;

maxsteps = 2000;  % maximum number of steps per round
alpha = 0.1;   % learning rate
gamma = 0.95;  % discount factor
epsilon = 0.1;   % probability of a random action selection

grafica = true;
xpoints=[];
ypoints=[];

t = 0;
for i = 1:max_round
    [total_reward, steps, Q, Model] = Episode(maxsteps, Q, Model, alpha, gamma, epsilon, statelist, actionlist, grafica, maze, start, goal, p_steps);
    
    disp(['Round: ',int2str(i),'  Steps:',int2str(steps)])
    xpoints(i)=i;
    ypoints(i)=steps;
    subplot(2,1,2);    
    plot(xpoints,ypoints)      
    title(['Round: ',int2str(i)])    
    t = t + steps;  
    
    drawnow
    
end

disp(['Total number of Steps:',num2str(t)]);