function Q = UpdateQLearning(s, a, r, sp, Q, alpha, gamma)
    % UpdateQ update de Qtable and return it using Whatkins Q-Learing
    % s: previous state before taking action (a)
    % sp: current state after action (a)
    % r: reward received from the environment after taking action (a) in state
    %                                             s and reaching the state sp
    % a:  the last executed action
    % alpha: learning rate
    % gamma: discount factor
    % Q: the Qtable

    TD_error = ((r + gamma*max(Q(sp,:))) - Q(s,a));
    Q(s,a) = Q(s,a) + alpha * TD_error;
end
