function [ a ] = greedy_selection( Q , s, epsilon )
% e_greedy_selection selects an action using Epsilon-greedy strategy
% Q: the QTtable
% s: the current state


    % # of states in the list
    nactions = size(Q,2);
	
    % if larger less than the epsilon, will do a random move
    if (rand()>epsilon) 
        a = GetBestAction(Q,s);    
    else
    % selects a random action based on a uniform distribution
    a = randi(nactions);
    end
end

